=== debian/changelog ===
cbmc (5.12-5) unstable; urgency=low

  * Disable regression tests that take too long on mipsel.

 -- Michael Tautschnig <mt@debian.org>  Mon, 04 May 2020 13:06:54 +0100

cbmc (5.12-4) unstable; urgency=low

  * __float128 is not available on ppc64el (again)
  * Fix acceptable test input
  * Simplify big-endian byte updates

 -- Michael Tautschnig <mt@debian.org>  Fri, 01 May 2020 07:06:38 +0100

cbmc (5.12-3) unstable; urgency=low

  * Fix endianness assumptions in tests
  * __float128 is not available on all architectures (again)

 -- Michael Tautschnig <mt@debian.org>  Thu, 30 Apr 2020 16:26:35 +0100

cbmc (5.12-2) unstable; urgency=low

  * __float128 is not available on all architectures
  * Fix endianness conversion in ELF reader

 -- Michael Tautschnig <mt@debian.org>  Wed, 29 Apr 2020 10:34:10 +0100

cbmc (5.12-1) unstable; urgency=low

  * New upstream release
  * Updated Standards version to 4.5.0.1 (no changes required)
  * Acknowledge NMU - thanks Adrian for the build fix (Closes: #952256)

 -- Michael Tautschnig <mt@debian.org>  Tue, 28 Apr 2020 15:32:56 +0100

cbmc (5.10-5.1) unstable; urgency=low

  * Non-maintainer upload.
  * Build fixes:
    - Fix the build with libmaven-compiler-plugin-java 3.8.1.
    - Backport upstream fix for building with new bison.
    (Closes: #952256)

 -- Adrian Bunk <bunk@debian.org>  Tue, 07 Apr 2020 11:55:23 +0300
