=== debian/control ===
Source: cbmc
Section: science
Priority: optional
Maintainer: Michael Tautschnig <mt@debian.org>
Build-Depends: debhelper-compat (= 13), minisat (>= 1:2.2.1-2), zlib1g-dev,
 flex, bison, default-jdk-headless, maven, maven-repo-helper,
 maven-debian-helper, gdb,
 libmaven-compiler-plugin-java (>= 3.8.1),
 libmaven-compiler-plugin-java (<< 3.8.2~)
Standards-Version: 4.5.0.1
Homepage: http://www.cprover.org/cbmc/
Rules-Requires-Root: no

Package: cbmc
Architecture: any
Depends: gcc, ${shlibs:Depends}, ${misc:Depends}
Suggests: gdb
Description: bounded model checker for C and C++ programs
 CBMC generates traces that demonstrate how an assertion can be violated, or
 proves that the assertion cannot be violated within a given number of loop
 iterations.
